| The Gaudi Framework v32r1 (f65d50dc)

Classes | Public Member Functions | List of all members
IIncidentSvc Class Referenceabstract

The interface implemented by the IncidentSvc service. More...

`#include <GaudiKernel/IIncidentSvc.h>`

Inheritance diagram for IIncidentSvc:
[legend]
Collaboration diagram for IIncidentSvc:
[legend]

## Classes
class | IncidentPack

## Public Member Functions
| DeclareInterfaceID (IIncidentSvc, 2, 0)
| InterfaceID. More...
virtual void | addListener (IIncidentListener *lis, const std::string &type="", long priority=0, bool rethrow=false, bool singleShot=false)=0
| Add listener. More...
virtual void | removeListener (IIncidentListener *lis, const std::string &type="")=0
| Remove listener. More...
virtual void | getListeners (std::vector< IIncidentListener * > &lis, const std::string &type="") const =0
virtual void | fireIncident (const Incident &incident)=0
| Fire an Incident. More...
virtual IIncidentSvc::IncidentPack | getIncidents (const EventContext *ctx)=0
virtual void | fireIncident (std::unique_ptr< Incident > incident)=0
| Fire an Incident, Incident ownership has to be passed to the service since it is going to be accessed asynchronously. More...
Public Member Functions inherited from IInterface
virtual void * | i_cast (const InterfaceID &) const =0
| main cast function More...
virtual std::vector< std::string > | getInterfaceNames () const =0
| Returns a vector of strings containing the names of all the implemented interfaces. More...
virtual unsigned long | addRef ()=0
| Increment the reference count of Interface instance. More...
virtual unsigned long | release ()=0
| Release Interface instance. More...
virtual unsigned long | refCount () const =0
| Current reference count. More...
virtual StatusCode | queryInterface (const InterfaceID &ti, void **pp)=0
| Set the void** to the pointer to the requested interface of the instance. More...
virtual | ~IInterface ()=default
| Virtual destructor. More...

## Additional Inherited Members
Public Types inherited from IInterface
enum | Status : StatusCode::code_t { Status::FAILURE = 0, Status::SUCCESS = 1, Status::NO_INTERFACE, Status::VERSMISMATCH, Status::LAST_ERROR }
| Return status. More...
using | iid = Gaudi::InterfaceId< IInterface, 0, 0 >
| Interface ID. More...
using | ext_iids = Gaudi::interface_list< iid >
| Extra interfaces. More...
Static Public Member Functions inherited from IInterface
static const InterfaceID & | interfaceID ()
| Return an instance of InterfaceID identifying the interface. More...

## Detailed Description

The interface implemented by the IncidentSvc service.

It is used by Listeners to declare themselves that they are interested by Incidents of a certain type and by Incident originators.

Author
  Pere Mato

Definition at line 23 of file IIncidentSvc.h.

## Member Function Documentation

## ◆ addListener()

virtual void IIncidentSvc::addListener | ( | IIncidentListener * | lis,
|  | const std::string & | type = `""`,
|  | long | priority = `0`,
|  | bool | rethrow = `false`,
|  | bool | singleShot = `false`
| ) |  |
| pure virtual

Add listener.

Parameters

  lis | Listener address
  type | Incident type
  priority | Priority in handling incident

## ◆ DeclareInterfaceID()

IIncidentSvc::DeclareInterfaceID | ( | IIncidentSvc | ,
|  | 2 | ,
|  | 0 |
| ) |  |

InterfaceID.

## ◆ fireIncident() [1/2]

virtual void IIncidentSvc::fireIncident | ( | const Incident & | incident | ) |
| pure virtual

Fire an Incident.

Parameters

  Incident | being fired

## ◆ fireIncident() [2/2]

virtual void IIncidentSvc::fireIncident | ( | std::unique_ptr< Incident > | incident | ) |
| pure virtual

Fire an Incident, Incident ownership has to be passed to the service since it is going to be accessed asynchronously.

Parameters

  Incident | being fired

## ◆ getIncidents()

virtual IIncidentSvc::IncidentPack IIncidentSvc::getIncidents | ( | const EventContext * | ctx | ) |
| pure virtual

## ◆ getListeners()

virtual void IIncidentSvc::getListeners | ( | std::vector< IIncidentListener * > & | lis,
|  | const std::string & | type = `""`
| ) |  | const
| pure virtual

## ◆ removeListener()

virtual void IIncidentSvc::removeListener | ( | IIncidentListener * | lis,
|  | const std::string & | type = `""`
| ) |  |
| pure virtual

Remove listener.

Parameters

  lis | Listener address
  type | Incident type

The documentation for this class was generated from the following file:

- GaudiKernel/GaudiKernel/IIncidentSvc.h